/*********************************************************************
/*********************************************************************
 *                                                                   *
 * Copyright (C) LANSA Group. All rights reserved                    *
 *                                                                   *
 *********************************************************************/

function DEFINE_EXTENSION_axMultitypeInputbox()
{
    var inputTypes = 
    [
        {
            value   : "",
            text    : "",
            property:
            {
                value:
                {
                    type       : "String", 
                    description: TEXT.dev( "axMultitypeInputbox.initVal" )
                },
                style:
                {
                    type       : "Style", 
                    description: TEXT.dev( "axMultitypeInputbox.style" )
                }
            }
        },
        {
            value   : "color",
            text    : TEXT.dev( "axMultitypeInputbox.inputType.color" ),
            property:
            {
                value:
                {
                    type       : "String", 
                    description: TEXT.dev( "axMultitypeInputbox.initVal" ),
                    v          : "#000000"
                },
                style:
                {
                    type       : "Style", 
                    description: TEXT.dev( "axMultitypeInputbox.style" )
                }
            }
        },
        {
            value   : "email",
            text    : TEXT.dev( "axMultitypeInputbox.inputType.email" ),
            property:
            {
                multiple:
                {
                    type       : "Boolean", 
                    description: TEXT.dev( "axMultitypeInputbox.mutipleEmail" )
                },
                value:
                { 
                    type       : "String", 
                    description: TEXT.dev( "axMultitypeInputbox.initVal" )
                },
                maxLength:
                {
                    type       : "Number", 
                    description: TEXT.dev( "axMultitypeInputbox.maxCharacterLength" ),
                    v          : 524288
                },
                style:
                {
                    type       : "Style", 
                    description: TEXT.dev( "axMultitypeInputbox.style" )
                }
            }
        },
        {
            value   : "file",
            text    : TEXT.dev( "axMultitypeInputbox.inputType.file" ),
            property:
            {
                type:
                {
                    type       : "String", 
                    items      : [
                                   { value: "all",   text: TEXT.dev( "axMultitypeInputbox.fileType.all" )   },
                                   { value: "audio", text: TEXT.dev( "axMultitypeInputbox.fileType.audio" ) },
                                   { value: "image", text: TEXT.dev( "axMultitypeInputbox.fileType.image" ) },
                                   { value: "video", text: TEXT.dev( "axMultitypeInputbox.fileType.video" ) }
                                 ],
                    description: TEXT.dev( "axMultitypeInputbox.fileFilter" )
                },
                multiple:
                {
                    type       : "Boolean", 
                    description: TEXT.dev( "axMultitypeInputbox.multipleFile" )
                },
                style:
                {
                    type       : "Style", 
                    description: TEXT.dev( "axMultitypeInputbox.style" )
                }
            }
        },
        {
            value   : "furigana",
            text    : TEXT.dev( "axMultitypeInputbox.inputType.furigana" ),
            property:
            {
                kanaType:
                {
                    type       : "String",
                    items      : [
                                   { value: "Hiragana", text: TEXT.dev( "axMultitypeInputbox.kanaType.hiragana" ) },
                                   { value: "Katakana", text: TEXT.dev( "axMultitypeInputbox.kanaType.katakana" ) }
                                 ],
                    v          : "Hiragana",
                    description: TEXT.dev( "axMultitypeInputbox.kanaType" )
                },
                showCaption:
                { 
                    type         : "Boolean", 
                    defaultStatic: true, 
                    description  : TEXT.dev( "axMultitypeInputbox.furiganaShowCaption" )
                },
                nameStyle:
                {
                    type       : "Style",
                    description: TEXT.dev( "axMultitypeInputbox.nameStyle" )
                },
                nameCaption:
                {
                    type       : "String",
                    v          : "名前",
                    description: TEXT.dev( "axMultitypeInputbox.nameCaption" )
                },
                kanaStyle:
                {
                    type       : "Style",
                    v          : { left: "190px" },
                    description: TEXT.dev( "axMultitypeInputbox.kanaStyle" )
                }
            }
        },
        {
            value   : "number",
            text    : TEXT.dev( "axMultitypeInputbox.inputType.number" ),
            property:
            {
                value:
                {
                    type       : "Number", 
                    description: TEXT.dev( "axMultitypeInputbox.initVal" ),
                    v          : 0
                },
                style:
                {
                    type       : "Style", 
                    description: TEXT.dev( "axMultitypeInputbox.style" )
                },
                minNum:
                {
                    type       : "Number",
                    description: TEXT.dev( "axMultitypeInputbox.number.minimum" ),
                    v          : 0
                },
                maxNum:
                {
                    type       : "Number",
                    description: TEXT.dev( "axMultitypeInputbox.number.maximum" ),
                    v          : 10
                },
                step:
                {
                    type       : "Number",
                    description: TEXT.dev( "axMultitypeInputbox.step" ),
                    v          : 1
                }
            }
        },
        {
            value   : "password",
            text    : TEXT.dev( "axMultitypeInputbox.inputType.password" ),
            property:
            {
                value:
                { 
                    type       : "String", 
                    description: TEXT.dev( "axMultitypeInputbox.initVal" )
                },
                style:
                {
                    type       : "Style", 
                    description: TEXT.dev( "axMultitypeInputbox.style" )
                },
                maxLength:
                {
                    type       : "Number", 
                    description: TEXT.dev( "axMultitypeInputbox.maxCharacterLength" ),
                    v          : 524288
                }
            }
        }
    ];

    var definition_MultitypeInputbox  =
    {
        display: TEXT.dev( "axMultitypeInputbox.display" ),
        group  : "vis",
        name   : "axMultitypeInputbox",
        type   : "element",

        properties:
        {
            inputType:
            {
                type       : "String", 
                items      : [],
                description: TEXT.dev( "axMultitypeInputbox.inputType" )
            },
            onChange:
            {
                type          : "Event", 
                description   : TEXT.dev( "axMultitypeInputbox.onChange" ),
                defaultDynamic: "" 
            },
            onFocus:
            {
                type          : "Event", 
                description   : TEXT.dev( "axMultitypeInputbox.onFocus" ),
                defaultDynamic: "" 
            },
            onBlur:
            { 
                type          : "Event", 
                description   : TEXT.dev( "axMultitypeInputbox.onBlur" ),
                defaultDynamic: "" 
            }
        },

        _inputType : "",

        _furiganaVars:
        {
            kanaType         : "Hiragana",
            baseKana         : '',
            inputText        : '',
            inputLabel       : '名前',
            values           : [],
            ignoreString     : '',
            eventObj         : null,
            timer            : null,
            convertFlag      : false,
            extractionPattern: null,
            compactingPattern: null,
            showCaption      : true
        },

        init: function( field, fieldDiv )
        {
            this._field = field;
            this._div   = fieldDiv;

            if ( !AXES.isTS2Engine )
            {
                alert( TEXT.dev( "axMultitypeInputbox.notSupported2" ) );
                this.notSupported = true;
                return;
            }

            var items = this.properties.inputType.items;
            var inputtypes = Modernizr.inputtypes;
            var supported, item;
            for ( var i in inputTypes )
            {
                item = inputTypes[ i ];
                supported = inputtypes[ item.value ];
                if ( supported || supported === undefined )
                    items.push(
                        {
                            value: item.value,
                            text : item.text
                        } 
                    );
            }

            var inputType = this.getPropertyValue( "inputType" );
            var supported = Modernizr.inputtypes[ inputType ];
            if ( supported || supported === undefined )
                this._createInputElement( inputType );
            else
            {
                alert( TEXT.dev( "axMultitypeInputbox.notSupported", TEXT.Dev( "axMultitypeInputbox.inputType." + inputType ) ) );
                this.notSupported = true;
            }
        },

        /* Render this control onto the screen */
        render: function( field, fieldDiv )
        {
            if ( this.notSupported )
            {
                this.properties = {};
                return;
            }

            var inputType = this.getPropertyValue( "inputType" );
            if ( this._inputType != inputType )
            {
                this._destroyElement();
                this._createInputElement( inputType );
                AXES.Dev.ExtensionsTab.selectFieldById( field.id );
            }

            if ( "furigana" == inputType )
            {
                var furiganaVars = this._furiganaVars;

                if ( furiganaVars.showCaption != this.getPropertyValue( "showCaption" ) )
                {
                    this._destroyFuriganaElements();
                    this._createFuriganaElements();
                    furiganaVars.showCaption = !furiganaVars.showCaption;
                }
                else if ( furiganaVars.inputLabel != this.getPropertyValue( "nameCaption" ) )
                {
                    this._destroyFuriganaElements();
                    this._createFuriganaElements();
                    furiganaVars.inputLabel = this.getPropertyValue( "nameCaption" );
                }
                else if ( furiganaVars.kanaType != this.getPropertyValue( "kanaType" ) )
                {
                    this._destroyFuriganaElements();
                    this._createFuriganaElements();
                    furiganaVars.kanaType = this.getPropertyValue( "kanaType" );
                }

                var nameStyle = this.getPropertyValue( "nameStyle" );
                furiganaVars.$inputDiv.css(
                    {
                        top : nameStyle.top,
                        left: nameStyle.left
                    }
                );

                delete nameStyle.position;
                delete nameStyle.top;
                delete nameStyle.left;
                this.applyStyle( nameStyle, this._$inputField[ 0 ], null );

                var kanaStyle = this.getPropertyValue( "kanaStyle" );
                furiganaVars.$kanaDiv.css(
                    {
                        top : kanaStyle.top,
                        left: kanaStyle.left
                    }
                );

                delete kanaStyle.position;
                delete kanaStyle.top;
                delete kanaStyle.left;
                this.applyStyle( kanaStyle, furiganaVars.kanaField, null );
                return;
            }

            var size = field.getSize();
            var inputField = this._$inputField[ 0 ];
            this.applyStyle(
                this.getPropertyValue( "style" ),
                inputField,
                {
                    position: "absolute",
                    width   : size.width,
                    height  : size.height
                }
            );

            switch ( inputType )
            {
            case "":
                inputField.value = this.getPropertyValue( "value" );
                break;
            case "color":
                inputField.value = this.getPropertyValue( "value" );
                break;
            case "email":
                inputField.value     = this.getPropertyValue( "value" );
                inputField.multiple  = this.getPropertyValue( "multiple" );
                inputField.maxLength = this.getPropertyValue( "maxLength" );
                break;
            case "file":
                inputField.multiple = this.getPropertyValue( "multiple" );
                var filter          = this.getPropertyValue( "type" );
                if ( "all" != filter )
                    inputField.accept = filter + "/*";
                break;
            case "number":
                inputField.min   = this.getPropertyValue( "minNum" );
                inputField.max   = this.getPropertyValue( "maxNum" );
                inputField.step  = this.getPropertyValue( "step" );
                inputField.value = this.getPropertyValue( "value" );
                break;
            case "password":
                inputField.value     = this.getPropertyValue( "value" );
                inputField.maxLength = this.getPropertyValue( "maxLength" );
                break;
            }
        },

        /* Clean up */
        destroy: function( field, fieldDiv )
        {
            this._destroyElement();
            this._field = null;
            this._div   = null;
        },

        _onChange: function( e )
        {
            var self = e.data;
            if ( self.isDesignMode() )
            {
                return;
            }

            self._noFieldValueChangedEvent = true;
            self._field.setValue( self._$inputField[ 0 ].value );

            self.raiseEvent( "onChange" );
        },

        _onChangeFurigana: function( e )
        {
            var self = e.data;
            if ( self.isDesignMode() ) return;

            self.raiseEvent( "onChange" );
        },

        _onFocus: function( e )
        {
            var self = e.data;
            if ( self.isDesignMode() )
            {
                return;
            }
            self.raiseEvent( "onFocus" );
        },

        _onFocusFurigana: function( e )
        {
            var self = e.data;
            if ( !self.isDesignMode() )
                self.raiseEvent( "onFocus" );
            self._furiganaVars.eventObj = window.event ? window.event.srcElement : e.target;
            self._setStateFurigana();
            self._setIntervalFurigana();
        },

        _onKeydownFurigana: function( e )
        {
            var self = e.data;
            if ( !self.isDesignMode() )
                self.raiseEvent( "onKeydown" );
            if ( self._furiganaVars.convertFlag )
                self._setStateFurigana();
        },

        _onBlur: function( e )
        {
            var self = e.data;
            if ( !self.isDesignMode() )
                self.raiseEvent( "onBlur" );
        },

        _onBlurFurigana: function( e )
        {
            var self = e.data;
            if ( !self.isDesignMode() )
                self.raiseEvent( "onBlur" );
            clearInterval( self._furiganaVars.timer );
        },

        _createInputElement: function( inputType )
        {
            this._inputType = inputType;
            this._adjustProperties();

            var $fieldDiv = $( this._div );
            if ( "furigana" == inputType )
                this._createFuriganaElements();
            else
            {
                $fieldDiv.append( '<input type="' + ( "" == inputType ? "text" : inputType ) + '"/>' );
                this._$inputField = $fieldDiv.find( "input" )
                    .bind( "focus",  this, this._onFocus )
                    .bind( "blur",   this, this._onBlur )
                    .bind( "change", this, this._onChange )
                    .bind( "input", this, this._onChange );
                this.applyTabIndex( this._$inputField[ 0 ] );
            }
        },

        _createFuriganaElements: function()
        {
            var $fieldDiv   = $( this._div );
            var showCaption = this.getPropertyValue( "showCaption" );

            $fieldDiv.append(
                '<div style="position:absolute"> \
                    <label>' + ( showCaption ? this.getPropertyValue( "nameCaption" ) : '' ) + '</label> \
                    <input type="text"/> \
                </div> \
                <div style="position:absolute"> \
                    <label>' + ( showCaption ? ( "Hiragana" == this.getPropertyValue( "kanaType" ) ? "かな" : "カナ" ) : '' ) + '</label> \
                    <input type="text"/> \
                </div>'
            );

            var furiganaVars = this._furiganaVars;
            furiganaVars.$inputDiv   = $( $fieldDiv.find( "div" )[ 0 ] );
            furiganaVars.$inputLabel = furiganaVars.$inputDiv.find( "label" );

            this._$inputField = furiganaVars.$inputDiv.find( "input" )
                .bind( "focus",   this, this._onFocusFurigana )
                .bind( "keydown", this, this._onKeydownFurigana )
                .bind( "blur",    this, this._onBlurFurigana )
                .bind( "change",  this, this._onChangeFurigana )
                .bind( "input",  this, this._onChangeFurigana );
            this._inputField = this._$inputField[ 0 ];
            this.applyTabIndex( this._inputField );

            furiganaVars.$kanaDiv   = $( $fieldDiv.find( "div" )[ 1 ] );
            furiganaVars.$kanaLabel = furiganaVars.$kanaDiv.find( "label" );
            furiganaVars.kanaField  = furiganaVars.$kanaDiv.find( "input" )[ 0 ];
            this._kanaField = furiganaVars.kanaField;

            furiganaVars.extractionPattern = new RegExp( '[^ 　ぁあ-んー]', 'g' );
            furiganaVars.compactingPattern = new RegExp( '[ぁぃぅぇぉっゃゅょ]', 'g' );
        },

        _destroyElement: function()
        {
            if ( !this._$inputField )
            {
                return;
            }

            this._$inputField.unbind();
            if ( "furigana" == this._inputType )
                this._destroyFuriganaElements();
            else
                this._$inputField.remove();
            delete this._$inputField;
        },

        _destroyFuriganaElements: function()
        {
            var furiganaVars = this._furiganaVars;
            furiganaVars.$inputDiv.remove();
            furiganaVars.$kanaDiv.remove();

            delete furiganaVars.$inputLabel;
            delete furiganaVars.$inputDiv;
            delete furiganaVars.kanaField;
            delete furiganaVars.$kanaLabel;
            delete furiganaVars.$kanaDiv;
        },

        _adjustProperties: function()
        {
            var index;
            var len = inputTypes.length;
            var inputType = this._inputType;
            for ( index = 0; index < len; index++ )
                if ( inputType == inputTypes[ index ].value )
                    break;
            var _properties = this.properties;
            var properties = {};
            for ( var i in _properties )
                properties[ i ] = _properties[ i ];
            var prop;
            for ( var i = 0; i < index; i++ )
            {
                prop = inputTypes[ i ].property;
                for ( var j in prop )
                    delete properties[ j ];
            }
            for ( var i = index + 1; i < len; i++ )
            {
                prop = inputTypes[ i ].property;
                for ( var j in prop )
                    delete properties[ j ];
            }

            prop = inputTypes[ index ].property;
            for ( var j in prop )
                if ( properties[ j ] === undefined )
                    properties[ j ] = ( _properties[ j ] === undefined || _properties[ j ].v === undefined ) ? prop[ j ] : _properties[ j ];

            var props = [];
            for ( var j in properties )
                props.push( j );
            props.sort();

            var propInfo, newProp, name;
            var newProps = {};
            for ( var i in props )
            {
                name = props[ i ];
                propInfo = properties[ name ];
                newProp = AXES.Objects.createObject( propInfo.type );
                if ( newProp )
                {
                    newProp._name    = name;
                    newProp._owner   = this;
                    newProps[ name ] = jQuery.extend( true, newProp, propInfo );
                }
            }
            this.properties = newProps;
        },

        _setStateFurigana: function()
        {
            var furiganaVars          = this._furiganaVars;
            furiganaVars.baseKana     = furiganaVars.kanaField.value;
            furiganaVars.convertFlag  = false;
            furiganaVars.ignoreString = furiganaVars.eventObj.value;
        },

        _setIntervalFurigana: function()
        {
            var self = this;
            var furiganaVars = this._furiganaVars;
            furiganaVars.timer = setInterval(
                function()
                {
                    var newInput = furiganaVars.eventObj.value;
                    if ( newInput == '' )
                    {
                        furiganaVars.baseKana     = '';
                        furiganaVars.ignoreString = '';
                        furiganaVars.inputText    = '';
                        furiganaVars.convertFlag  = false;
                        furiganaVars.values       = [];
                        self._setKanaFurigana();
                        return;
                    }

                    if ( newInput.match( furiganaVars.ignoreString ) )
                        newInput = newInput.replace( furiganaVars.ignoreString, '' );
                    else
                    {
                        var ignoreArray = furiganaVars.ignoreString.split( '' );
                        var inputArray = newInput.split( '' );
                        var len = ignoreArray.length;
                        for( var i = 0; i < len; i++ )
                            if ( ignoreArray[ i ] == inputArray[ i ] )
                                inputArray[ i ] = '';
                        newInput = inputArray.join( '' );
                    }

                    if ( furiganaVars.inputText == newInput )
                    {
                        return;
                    }

                    furiganaVars.inputText = newInput;
                    if ( !furiganaVars.convertFlag )
                    {
                        var newVal = newInput.replace( furiganaVars.extractionPattern, '' ).split( '' );
                        if ( Math.abs( furiganaVars.values.length - newVal.length ) > 1 )
                        {
                            if ( Math.abs( furiganaVars.values.length - ( newVal.join( '' ).replace( furiganaVars.compactingPattern, '' ).split( '' ) ).length ) > 1 )
                                self._changeStateFurigana();
                        }
                        else if ( furiganaVars.values.length == furiganaVars.inputText.length && furiganaVars.values.join( '' ) != furiganaVars.inputText )
                            self._changeStateFurigana();

                        self._setKanaFurigana( newVal );
                    }
                },
                30
            );
        },

        _setKanaFurigana: function( newVal )
        {
            var furiganaVars = this._furiganaVars;
            if ( furiganaVars.convertFlag )
            {
                return;
            }

            if ( newVal )
                furiganaVars.values = newVal;
            if ( "Hiragana" == this.getPropertyValue( "kanaType" ) )
            {
                furiganaVars.kanaField.value = furiganaVars.baseKana + furiganaVars.values.join( '' );
                return;
            }

            var val    = "";
            var curVal = furiganaVars.baseKana + furiganaVars.values.join( '' );
            var len    = curVal.length;
            var c;
            for ( var i = 0; i < len; i++ )
            {
                c = curVal.charCodeAt( i );
                val += ( ( c >= 12353 && c <= 12435 ) || c == 12445 || c == 12446 ) ? String.fromCharCode( c + 96 ) : curVal.charAt( i );
            }
            furiganaVars.kanaField.value = val;
        },

        _changeStateFurigana: function()
        {
            var furiganaVars = this._furiganaVars;
            furiganaVars.baseKana    = furiganaVars.baseKana + furiganaVars.values.join( '' );
            furiganaVars.convertFlag = true;
            furiganaVars.values      = [];
        },

        /* Handles the change in field value.  For example, if a button script on the form does a FIELDS("ThisExtension").setValue("ABC"), we want this textbox to display "ABC".  This event handles that */
        _onFieldValueChanged: function( event )
        {
            var self = this;
            if ( !self._noFieldValueChangedEvent )
                self.render( self._field, self._div );
            else
                delete self._noFieldValueChangedEvent;
        }
    };

    var prop;
    var properties = definition_MultitypeInputbox.properties;
    for ( var i in inputTypes )
    {
        prop = inputTypes[ i ].property;
        for ( var j in prop )
            properties[ j ] = prop[ j ];
    }

    /* Register the extension with AXES */
    AXES.Extensions.add( definition_MultitypeInputbox );
}

/* Self define this extension */
DEFINE_EXTENSION_axMultitypeInputbox();

